/**
	$Id: PingRequestHandler.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.jobagent.handlers;

import java.net.Socket;

import net.sf.basedb.clients.jobagent.Agent;
import net.sf.basedb.util.jobagent.RequestHandler;

/**
	This is a request handler for the <code>ping</code> command. It simply returns
	OK if the command is <code>ping</code>. Otherwise it returns 
	<code>FAILED Unhandled command: &lt;cmd&gt;</code>.

	@author nicklas
	@version 2.0
	@base.modified $Date: 2012-09-14 09:28:35 +0200 (fr, 14 sep 2012) $
*/
public class PingRequestHandler
	implements RequestHandler
{

	/**
		Create a new handler for the ping command.
		@param agent The agent 
	*/
	public PingRequestHandler(Agent agent)
	{}
	
	/*
		From the RequestHandler interface
		-------------------------------------------
	*/
	/**
		@return OK if <code>cmd=ping</code>
	*/
	@Override
	public String handleCmd(Socket incoming, String cmd)
	{
		return "ping".equals(cmd) ? "OK" : "FAILED Unhandled command: " + cmd;
	}
	// -------------------------------------------

}
