<%-- $Id: impersonate.jsp 6167 2012-10-12 09:32:41Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String error = Values.getString(request.getParameter("error"), null);
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
ItemResultList<News> news = null;
try
{
	User currentUser = null;
	int userId = Values.getInt(request.getParameter("user_id"));
	if (userId != 0) currentUser = User.getById(dc, userId);
	%>
	<base:page type="popup" title="Impersonate user">
	<base:head scripts="~login.js" styles="login.css" />
	<base:body>
		<h1>Impersonate user <base:help helpid="impersonateuser" /></h1>
		<form name="login" action="login.jsp" method="post">
		<input type="hidden" name="cmd" value="Impersonate">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="again" value="1">
		<input type="hidden" name="redirect" value="">
	
		<div class="content">
			<table class="fullform input100 bottomborder">
			<%
			if (error != null) 
			{
				%>
				<tr>
					<td colspan="3">
					<div class="messagecontainer error"><%=error%></div>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>User</th>
				<td colspan="2">
					<base:select 
						id="user_id"
						clazz="selectionlist"
						required="true"
						current="<%=currentUser%>"
						recent="<%=null%>"
						newitem="true"
					/>
				</td>
				
			</tr>
			<tr>
				<th><label for="remainOnPage">Remain on page</label></th>
				<td>
					<input type="checkbox" name="remainOnPage" id="remainOnPage" checked value="1">
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Comment</th>
				<td>
					<textarea class="text" rows="6" name="comment" id="comment"></textarea>
				</td>
				<td>
					<base:zoom textarea="comment" title="Comment" />
				</td>
			</tr>
			</table>
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnLogin" image="login.png" title="Impersonate" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

