<%-- $Id: view_bioassay.jsp 6909 2015-05-18 06:48:30Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RootRawBioAssay"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.units.UnitConverter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.HashMap"
	import="java.util.LinkedList"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ROOTRAWBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String tabId = Values.getString(request.getParameter("tab"), "properties");
final DbControl dc = sc.newDbControl();
try
{
	RootRawBioAssay bioAssay = RootRawBioAssay.getById(dc, itemId);
	Experiment experiment = bioAssay.getExperiment();
	String title = null;
	
	ItemQuery<AnnotationType> efQuery = experiment.getExperimentalFactors();
	efQuery.include(Include.ALL);
	efQuery.order(Orders.asc(Hql.property("name")));
	ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
	SnapshotManager manager = new SnapshotManager();
	AnnotationSetSnapshot snapshot = bioAssay.isAnnotated() ? 
		manager.getSnapshot(dc, bioAssay.getAnnotationSet().getId()) : null;

	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	final boolean writePermission = bioAssay.hasPermission(Permission.WRITE);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssay);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~bioassays.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.edit-experimental-factor
		{
		 	float: right;
		}
		</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../index.jsp?ID="+ID+"&amp;cmd=ViewItem&amp;item_id="+experiment.getId()%>"
			/><p:pathelement title="<%=HTML.encodeTags(bioAssay.getName())%>"
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>

		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="<%=tabId%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this bioassay" : "You do not have permission to edit this bioassay"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="rootrawbioassay.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(bioAssay.getName())%></td>
			</tr>
			<tr>
				<th>Parent raw bioassay</th>
				<td><base:propertyvalue item="<%=bioAssay%>" property="rawBioAssay" />
			<tr>
				<th>Description</th>
				<td><%=HTML.encodeTags(bioAssay.getDescription())%></td>
			</tr>
			</table>
			</div>

			<base:section 
				id="experimentalFactors" 
				title="<%="Experimental factors (" + experimentalFactors.size() +")"%>"
				context="<%=cc%>"
				>
				<%
				if (experimentalFactors.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No experimental factors has been added to this experiment 
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<div style="width: 100%; max-width: 1000px;">
					<tbl:table
						id="tbl.experimentalFactors"
						columns="all"
						action="index.jsp"
						>
						<tbl:hidden name="item_id" value="<%=Integer.toString(itemId)%>" />
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef
							id="type"
							title="Value type"
						/>
						<tbl:columndef
							id="values"
							title="Values"
						/>
						<tbl:columndef
							id="item"
							title="Parent item"
						/>
						<tbl:columndef 
							id="note"
							title="Note"
						/>
						<tbl:columndef
							id="lastModified"
							title="Last modified"
							formatter="<%=dateTimeFormatter %>"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							AnnotationTypeFilter annotationTypeFilter = new AnnotationTypeFilter();
							for (AnnotationType at : experimentalFactors)
							{
								Type valueType = at.getValueType();
								annotationTypeFilter.setAnnotationType(at);
								List<AnnotationSnapshot> all = snapshot == null ? 
										null : manager.findAnnotations(dc, snapshot, annotationTypeFilter, true);
								
								List<?> values = null;
								Formatter formatter = FormatterFactory.getTypeFormatter(sc, valueType);
								Nameable parentItem = null;
								String parentType = "";
								if (all != null && all.size() > 0)
								{
									for (AnnotationSnapshot a : all)
									{
										boolean annotatePermission = a.hasPermission(dc, Permission.WRITE);
										Unit unit = a.getActualUnit(dc);
										UnitConverter converter = null;
										if (unit != null)
										{
											converter = unit.getUnitConverter(at.getDefaultUnit());
											formatter = unit.getFormatter(formatter);
										}
										values = a.getActualValues(converter, valueType);

										Date lastModified = a.getThisLastUpdate();
										boolean isUpToDate = a.isUpToDate();
										AnnotationSnapshot inherited = a.getInheritedFrom();
										if (inherited != null)
										{
											parentType = inherited.getItemType().toString();
											if (lastModified == null)
											{
												lastModified = inherited.getThisLastUpdate();
											}
											try
											{
												parentItem = (Nameable)inherited.getThisItem(dc);
												if (parentItem instanceof Subtypable)
												{
													ItemSubtype subtype = ((Subtypable)parentItem).getItemSubtype();
													if (subtype != null) parentType = subtype.getName();
												}
											}
											catch (PermissionDeniedException ex)
											{}
										}
										%>
										<tbl:row>
											<tbl:cell column="name"><base:icon 
												image="deleted.png" 
												tooltip="This item has been scheduled for deletion" 
												visible="<%=at.isRemoved()%>"
												/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
											<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
											<tbl:cell column="type">
												<%=valueType%>
												<%=at.isEnumeration() ? "(enumeration)" : ""%>
											</tbl:cell>
											<tbl:cell column="values">
												<%=Values.getString(values, ", ", true, formatter)%>
												<base:icon id="<%=Integer.toString(a.getThisAnnotationId())%>"
													image="<%=isUpToDate ? "edit.png" : "edit-outofsync.png"%>" 
													subclass="edit-experimental-factor auto-init" 
													data-auto-init="edit-experimental-factor"
													data-item-type="ROOTRAWBIOASSAY" 
													data-item-id="<%=itemId%>" 
													data-annotation-type-id="<%=at.getId()%>"
													data-annotation-id="<%=a.getThisAnnotationId()%>"
													tooltip="Edit this annotation" 
													visible="<%=annotatePermission %>"/>
											</tbl:cell>
											<tbl:cell column="item">
												<%
												if (parentItem != null)
												{
													%>
													<%=Base.getLinkedName(ID, parentItem, false, true)%>
													<span class="itemsubtype">(<%=parentType%>)</span>
													<%
												}
												else if (a.getSource() == Annotation.Source.CLONED)
												{
													%>
													<i>- missing -</i>
													<%
												}
												%>
											</tbl:cell>
											<tbl:cell column="note"><%=a.getSource() == Annotation.Source.CLONED ? "Cloned" + (isUpToDate ? "; up-to-date" : "; modified") : "" %></tbl:cell>
											<tbl:cell column="lastModified" value="<%=lastModified %>" />
										</tbl:row>
										<%
									}
								}
								else
								{
									%>
									<tbl:row>
										<tbl:cell column="name"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=at.isRemoved()%>"
											/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
										<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
										<tbl:cell column="type">
											<%=valueType%>
											<%=at.isEnumeration() ? "(enumeration)" : ""%>
										</tbl:cell>
									</tbl:row>
									<%
								}
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<div id="warning.missing" style="display: none; text-align: right;">
						<base:icon image="warning.png" /> = Some raw bioassays are missing this factor value
					</div>
				</div>
				<%
				}
				%>
			</base:section>

		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" clazz="white">
			<jsp:include page="../../../common/annotations/list_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>

		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
